Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

- Main Page
- Namespaces
- Classes
- Files
- Related Pages
- Examples

- Class List
- Class Hierarchy
- Class Members

# openvrml::material_node Class Reference

`#include <openvrml/node.h>`

Inheritance diagram for openvrml::material_node:

[legend]

List of all members.

## Detailed Description

Abstract base class for material nodes.

## Public Member Functions

virtual | ~material_node ()=0 throw ()
| Destroy.
virtual float | ambient_intensity () const =0 throw ()
| Get the ambient intensity.
virtual const color & | diffuse_color () const =0 throw ()
| Get the diffuse color.
virtual const color & | emissive_color () const =0 throw ()
| Get the emissive color.
virtual float | shininess () const =0 throw ()
| Get the shininess.
virtual const color & | specular_color () const =0 throw ()
| Get the specular color.
virtual float | transparency () const =0 throw ()
| Get the transparency.

## Protected Member Functions

| material_node (const node_type &type, const boost::shared_ptr< openvrml::scope > &scope) throw ()
| Construct.

## Private Member Functions

virtual material_node * | to_material () throw ()
| Cast to a `material_node`.

## Constructor & Destructor Documentation

openvrml::material_node::~material_node | ( |  | ) | throw ()`[pure virtual]`

Destroy.

openvrml::material_node::material_node | ( | const node_type & | type,
|  | const boost::shared_ptr< openvrml::scope > & | scope |
| ) |  |  | throw ()`[protected]`

Construct.

Parameters:

  `[in]` | type | the `node_type` associated with the node.
  `[in]` | scope | the `scope` the node belongs to.

## Member Function Documentation

float openvrml::material_node::ambient_intensity | ( |  | ) | const throw ()`[pure virtual]`

Get the ambient intensity.

Returns:
  the ambient intensity.

const openvrml::color & openvrml::material_node::diffuse_color | ( |  | ) | const throw ()`[pure virtual]`

Get the diffuse color.

Returns:
  the diffuse color.

const openvrml::color & openvrml::material_node::emissive_color | ( |  | ) | const throw ()`[pure virtual]`

Get the emissive color.

Returns:
  the emissive color.

float openvrml::material_node::shininess | ( |  | ) | const throw ()`[pure virtual]`

Get the shininess.

Returns:
  the shininess.

const openvrml::color & openvrml::material_node::specular_color | ( |  | ) | const throw ()`[pure virtual]`

Get the specular color.

Returns:
  the specular color.

float openvrml::material_node::transparency | ( |  | ) | const throw ()`[pure virtual]`

Get the transparency.

Returns:
  the transparency.

openvrml::material_node * openvrml::material_node::to_material | ( |  | ) | throw ()`[private, virtual]`

Cast to a `material_node`.

Returns:
  a pointer to this `material_node`.

Reimplemented from openvrml::node.